<template>
    <div class="video-monitor">
        <div class="drag-box" ref="drag-box">
            <div class="drag-left">
                <div class="site-tree">
                    <div class="common-tree-title">
                        <i class="el-icon-menu"></i> 业务目录
                    </div>
                    <div class="flex tree-search-con">
                        <!-- <el-select
        class="helf-search"
        v-model="treeKey"
        @change="changeVedeoF"
        placeholder="请选择"
        size="mini"
        :popper-append-to-body="false"
    >
        <el-option
            v-for="item in options"
            :key="item.id"
            :label="item.name"
            :value="item.code"
        >
        </el-option>
    </el-select> -->
                        <el-input
                            placeholder="输入关键字搜索"
                            v-model="filterText"
                            clearable
                            suffix-icon="el-icon-search"
                            size="small"
                        >
                        </el-input>
                    </div>
                    <div class="filter-tree-outer">
                        <el-tree
                            class="filter-tree editScroll"
                            :data="data"
                            :props="{value: 'code', label: 'name'}"
                            :filter-node-method="filterNode"
                            :current-node-key="currentNodeKey"
                            ref="tree1"
                            @node-click="nodeClick"
                            :highlight-current="true"
                            default-expand-all
                            :expand-on-click-node="false"
                        >
                            <span
                                class="custom-tree-node"
                                slot-scope="{node, data}"
                            >
                                <i
                                    v-if="data.type == 1"
                                    :class="[
                                        'el-icon-folder',
                                        {red: data.status == 0},
                                        {green: data.status == 1},
                                    ]"
                                ></i>
                                <i
                                    v-if="data.pointType == 1"
                                    :class="[
                                        'iconfont icon-qiangji',
                                        {red: data.status == 0},
                                        {green: data.status == 1},
                                    ]"
                                ></i>
                                <i
                                    v-if="data.pointType == 2"
                                    :class="[
                                        'iconfont icon-qiuji',
                                        {red: data.status == 0},
                                        {green: data.status == 1},
                                    ]"
                                ></i>
                                &nbsp;&nbsp; <span>{{ node.label }}</span
                                >&nbsp;&nbsp;
                            </span>
                        </el-tree>
                    </div>
                </div>
            </div>
            <div class="drag-resize" title="收缩侧边栏">⋮</div>
            <div class="drag-mid">
                <DHVideoPlayPlugin
                    class="videoWindow"
                    ref="DHVideoIframe"
                    :splitNum="4"
                />
            </div>
        </div>
    </div>
</template>

<script>
import {dragControllerDiv} from '@/mixins/dragControllerDiv'
import DHVideoPlayPlugin from './components/DHVideoPlayPlugin.vue'
import videoMonitor from '@/api/videoMonitorapi.js'

export default {
    name: 'VideoMonitor',
    components: {
        DHVideoPlayPlugin,
    },
    data() {
        return {
            platform: 'ZG',
            option: {},
            activeName: 'first',
            filterText: '',
            filterText2: '',
            treeKey: '',
            currentNodeKey: '',
            currentNodeKey2: '',
            currentNodeKey3: '',
            currentNode: null,
            options: [],
            data: [],
            data2: [],
            data3: [],
            defaultProps: {
                children: 'children',
                label: 'label',
            },
            queryParam: {
                pageBean: {
                    pageSize: 10,
                    page: 1,
                },
                params: {
                    treeKey: null,
                },
            },
        }
    },
    computed: {
        plusAndEditLight() {
            let light = false
            if (!this.currentNode) {
                light = false
            } else {
                let isRoot = this.currentNode.data.id == 0 ? true : false
                if (isRoot || !this.currentNode.childNodes.length) {
                    light = false
                } else if (!isRoot && this.currentNode.childNodes.length) {
                    light = true
                }
            }
            return light
        },
        deleteLight() {
            let light = false
            if (!this.currentNode) {
                light = false
            } else {
                let isRoot = this.currentNode.data.id == 0 ? true : false
                if (isRoot) {
                    light = false
                } else {
                    light = true
                }
            }
            return light
        },
        upDownLight() {
            let light = false
            if (!this.currentNode) {
                light = false
            } else if (!this.currentNode.childNodes.length) {
                light = true
            }
            return light
        },
    },
    watch: {
        filterText(val) {
            this.$refs.tree1.filter(val)
        },
        filterText2(val) {
            this.$refs.tree2.filter(val)
        },
    },
    mounted() {
        dragControllerDiv()
        this.getTreen()
        this.$bus.$on('showPopper', (size) => {
            this.cutWindowSelect(size)
        })
        this.$bus.$on('hidePopper', () => {
            this.$nextTick(() => {
                if (this.$refs && this.$refs.videoIframe) {
                    this.$refs.videoIframe.repairWindow()
                }
            })
        })
    },
    methods: {
        cutWindowSelect(size) {
            this.$nextTick(() => {
                let sizeV = this.$refs.videoIframe.$el.getBoundingClientRect()
                let iLeft, iTop, iWidth, iHeight
                iLeft = size.left - sizeV.left - 2
                iTop = size.top - sizeV.top
                iWidth = size.width
                iHeight = size.height + 4
                this.$refs.videoIframe.cutWindow(iLeft, 0, iWidth, iHeight)
            })
        },
        // 根据监控点获取视频流地址
        getSiteVideoURL(cameraIndexCode) {
            let query = {
                cameraIndexCode, // 监控点编码
            }
            this.$http
                .post('${portal}/biz/catalog/base/previewURLs', query)
                .then((res) => {
                    if (res.data.state && res.data.value) {
                        let data = res.data.value
                        this.$nextTick(() => {
                            this.$refs.videoIframe.useVideoURL(data)
                        })
                    } else {
                        this.$message.warning('获取监控点资源失败！')
                    }
                })
        },
        getDateList() {
            videoManger.getListPage(this.queryParam, (res) => {
                if (res.state) {
                    this.tableData = res.value
                    this.total = res.value.total
                    this.relationList.rscd = this.relation
                    this.loading = false
                }
            })
        },
        getTreen() {
            videoMonitor.getVideoF({}, (res) => {
                this.options = res.value
                this.treeKey = this.options[0].code
                this.query = {
                    zoneCode: this.treeKey,
                }
                videoMonitor.getVideoTreeSite(this.query, (res) => {
                    this.data = res.value
                    this.queryParam.params.treeKey = this.data[0].code
                })
                // videoMonitor.getVideoTree(this.query, (res) => {
                //     this.data = res.value
                //     // console.log(this.videoTree,666)
                //     this.queryParam.params.treeKey = this.data[0].code
                // })
            })
        },
        changeVedeoF(val) {
            if (val) {
                this.treeKey = val
                this.query = {
                    zoneCode: val,
                }
                videoMonitor.getVideoTreeSite(this.query, (res) => {
                    this.data = res.value
                })
                let obj = this.options.find((item) => item.code == val)
                if (obj && obj.platform) {
                    this.platform = obj.platform
                }
            } else {
                this.data = []
                this.$set(this.data, this.data, res.value)
            }
        },
        handlePlus() {},
        handleEdit() {},
        handleDelete() {},
        handleNodeUp() {},
        handleNodeDown() {},
        handleClick(item) {},
        nodeClick(data, node, nodeD) {
            console.log(data, node, nodeD)
            this.currentNodeKey = data.id
            this.currentNode = node
            this.queryParam.params.treeKey = data.code
            if (data.type == 2) {
                this.$nextTick(() => {
                    this.$refs.DHVideoIframe.realTimeVideo(data.code)
                })
                // this.$nextTick(() => {
                //     this.$refs.easyPlayer.getUrlAndPlay(data.code, data.name)
                // })
            }

            // if (data.type == 2 && data.platform == 'HK') {
            // this.platform = data.platform
            //     this.$nextTick(() => {
            //         this.$refs.videoIframe.play(data.code)
            //     })
            // } else if (data.type == 2 && data.platform == 'ZG') {
            // this.platform = data.platform
            //     this.$nextTick(() => {
            //         this.$refs.easyPlayer.getUrlAndPlay(data.code)
            //     })
            // }
        },
        filterNode(value, data) {
            if (!value) return true
            return data.name.indexOf(value) !== -1
        },
        filterNode2(value, data) {
            if (!value) return true
            return data.name.indexOf(value) !== -1
        },
    },
}
</script>

<style lang="scss" scoped>
// @import './css/screen.scss';
$border-color: #566a7e;
$active-color: #FFFFFF;
$high-light-color: #ff7c40;
$text-color: #000000;
$text-color-dark: #8993a0;
$dark-bg: #0b1926;
$dark-bg-lighter: #999999;
$active-bg-lighter: #ecf6ff;

.video-monitor {
  overflow: hidden;
  height: 100%;
  width: 100%;
  background: #ebeef5;
  box-sizing: border-box;
  // background-image: url('./../assets/img/waterbg5.jpg');
  // background-image: #ffffff;
  color: $text-color;
  position: relative;
  display: flex;
  justify-content: space-between;
  gap: 10PX;
}

#video-container {
  width: calc(100% - 320PX);
  height: 100%;
  position: relative;
}

.video-iframe {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  z-index: 1;
}

.videoWindow {
  width: 100%;
  height: 100%;
  // position: absolute;
  // right: 0;
  // top: 0;
  z-index: 1;
}

.site-tree {
  width: 100%;
  height: 100%;
  background: #ffffff;
//   box-shadow: inset 0 0 100px rgba(#000, 0.3);

  .tree-search-con {
    padding: 10px 10px;
    background-color: #FFFFFF;

    > div {
      width: calc(100% - 4PX);
      margin: 0 2PX;
    }

    .helf-search {
      width: calc(50% - 4PX);
    }
  }

  .common-tree-title {
    height: 46px;
    line-height: 46px;
    color: #1289fe;
    background-color: #d9e4ea;
    padding: 0 10px;
    font-weight: 700;
    font-size: 16px;
  }

  .tree-controler-con {
    width: calc(100% - 8px);
    margin: 4px auto;
    border-bottom: 1px solid $border-color;

    i {
      font-size: 16px;
      padding: 4px 8px 8px 8px;
      cursor: pointer;
      color: $active-color;
    }

    .light:hover {
      color: $high-light-color;
    }

    .disable {
      color: $text-color-dark;
      cursor: default
    }
  }

  .filter-tree-outer {
    height: calc(100% - 52PX - 46px);
  }

  .filter-tree-outer.short {
    height: calc(100% - 70PX);
  }

  ::v-deep .el-select .el-input--suffix .el-input__inner,
  ::v-deep .el-input--mini .el-input__inner {
    // background-color: #000;
    // border: 1px solid $border-color;
    color: $text-color;
  }

  ::v-deep .el-select-dropdown__item {
    height: 28PX;
    line-height: 28PX;
  }

  ::v-deep .el-scrollbar__wrap {
    margin-right: -8PX !important;
  }

  ::v-deep .el-tree {
    background: #ffffff;
    color: $text-color;
    border: none !important;
  }

  .editScroll {
    width: 100% !important;
    height: 100% !important;
    overflow: auto;
  }

  ::v-deep .el-tree-node:focus > .el-tree-node__content,
  ::v-deep .el-tree-node__content:hover,
  ::v-deep .el-tree--highlight-current .el-tree-node.is-current > .el-tree-node__content {
    background-color: $active-bg-lighter;
    // color: $active-color;
  }

  ::v-deep .el-tree-node__content {
    height: 38px !important;
  }

  ::v-deep .el-tree-node > .el-tree-node__children {
    overflow: visible;
  }

  .custom-tree-node {
    flex: 1;
    display: flex;
    align-items: center;
    justify-content: start;
    font-size: 14px;
    padding-right: 8px;
    span, i{
        font-size: 14PX;
    }
  }

  ::v-deep .el-tree-node__expand-icon {
    font-size: 14PX;
  }

  .videoWindow {
    width: 100%;
    height: 100%;
  }

  .el-icon-video-camera {
    font-weight: bold;
  }

  .red {
    color: #f56c6c
  }

  .green {
    color: #67c23a
  }

  .icon-qiangji {
    transform: rotateY(180deg);
  }
}
.drag-mid{
    background-color: #ffffff;
}
</style>
